# Generated from lib/parsing/NFA.g4 by ANTLR 4.8
# encoding: utf-8
from antlr4 import *
from io import StringIO
import sys
if sys.version_info[1] > 5:
	from typing import TextIO
else:
	from typing.io import TextIO


def serializedATN():
    with StringIO() as buf:
        buf.write("\3\u608b\ua72a\u8133\ub9ed\u417c\u3be7\u7786\u5964\3\17")
        buf.write("N\4\2\t\2\4\3\t\3\4\4\t\4\4\5\t\5\4\6\t\6\4\7\t\7\4\b")
        buf.write("\t\b\4\t\t\t\3\2\3\2\7\2\25\n\2\f\2\16\2\30\13\2\3\2\3")
        buf.write("\2\3\2\3\3\3\3\3\3\3\3\5\3!\n\3\3\4\3\4\3\4\3\4\3\4\5")
        buf.write("\4(\n\4\3\4\3\4\3\4\3\4\3\5\3\5\3\5\3\5\7\5\62\n\5\f\5")
        buf.write("\16\5\65\13\5\3\5\5\58\n\5\3\5\3\5\3\6\3\6\3\6\3\6\3\7")
        buf.write("\3\7\3\b\3\b\7\bD\n\b\f\b\16\bG\13\b\3\b\5\bJ\n\b\3\t")
        buf.write("\3\t\3\t\2\2\n\2\4\6\b\n\f\16\20\2\3\5\2\3\n\f\f\17\17")
        buf.write("\2L\2\22\3\2\2\2\4 \3\2\2\2\6\"\3\2\2\2\b-\3\2\2\2\n;")
        buf.write("\3\2\2\2\f?\3\2\2\2\16I\3\2\2\2\20K\3\2\2\2\22\26\5\4")
        buf.write("\3\2\23\25\5\6\4\2\24\23\3\2\2\2\25\30\3\2\2\2\26\24\3")
        buf.write("\2\2\2\26\27\3\2\2\2\27\31\3\2\2\2\30\26\3\2\2\2\31\32")
        buf.write("\5\n\6\2\32\33\5\16\b\2\33\3\3\2\2\2\34\35\7\3\2\2\35")
        buf.write("\36\7\4\2\2\36!\5\f\7\2\37!\3\2\2\2 \34\3\2\2\2 \37\3")
        buf.write("\2\2\2!\5\3\2\2\2\"#\7\5\2\2#$\5\f\7\2$\'\7\t\2\2%(\5")
        buf.write("\f\7\2&(\7\13\2\2\'%\3\2\2\2\'&\3\2\2\2()\3\2\2\2)*\7")
        buf.write("\6\2\2*+\7\4\2\2+,\5\b\5\2,\7\3\2\2\2-\67\7\7\2\2.\63")
        buf.write("\5\f\7\2/\60\7\t\2\2\60\62\5\f\7\2\61/\3\2\2\2\62\65\3")
        buf.write("\2\2\2\63\61\3\2\2\2\63\64\3\2\2\2\648\3\2\2\2\65\63\3")
        buf.write("\2\2\2\668\3\2\2\2\67.\3\2\2\2\67\66\3\2\2\289\3\2\2\2")
        buf.write("9:\7\b\2\2:\t\3\2\2\2;<\7\n\2\2<=\7\4\2\2=>\5\b\5\2>\13")
        buf.write("\3\2\2\2?@\7\f\2\2@\r\3\2\2\2AE\7\r\2\2BD\5\20\t\2CB\3")
        buf.write("\2\2\2DG\3\2\2\2EC\3\2\2\2EF\3\2\2\2FJ\3\2\2\2GE\3\2\2")
        buf.write("\2HJ\3\2\2\2IA\3\2\2\2IH\3\2\2\2J\17\3\2\2\2KL\t\2\2\2")
        buf.write("L\21\3\2\2\2\t\26 \'\63\67EI")
        return buf.getvalue()


class NFAParser ( Parser ):

    grammarFileName = "NFA.g4"

    atn = ATNDeserializer().deserialize(serializedATN())

    decisionsToDFA = [ DFA(ds, i) for i, ds in enumerate(atn.decisionToState) ]

    sharedContextCache = PredictionContextCache()

    literalNames = [ "<INVALID>", "'init'", "'='", "'('", "')'", "'{'", 
                     "'}'", "','", "<INVALID>", "<INVALID>", "<INVALID>", 
                     "'#'" ]

    symbolicNames = [ "<INVALID>", "INIT", "EQUALS", "LEFT_PARENTHESIS", 
                      "RIGHT_PARENTHESIS", "LEFT_BRACKET", "RIGHT_BRACKET", 
                      "COMMA", "FINAL", "EPSILON", "STATE", "HASH", "WS", 
                      "ANYCHAR" ]

    RULE_start = 0
    RULE_init = 1
    RULE_production = 2
    RULE_stateset = 3
    RULE_final = 4
    RULE_statename = 5
    RULE_comment = 6
    RULE_anyvalue = 7

    ruleNames =  [ "start", "init", "production", "stateset", "final", "statename", 
                   "comment", "anyvalue" ]

    EOF = Token.EOF
    INIT=1
    EQUALS=2
    LEFT_PARENTHESIS=3
    RIGHT_PARENTHESIS=4
    LEFT_BRACKET=5
    RIGHT_BRACKET=6
    COMMA=7
    FINAL=8
    EPSILON=9
    STATE=10
    HASH=11
    WS=12
    ANYCHAR=13

    def __init__(self, input:TokenStream, output:TextIO = sys.stdout):
        super().__init__(input, output)
        self.checkVersion("4.8")
        self._interp = ParserATNSimulator(self, self.atn, self.decisionsToDFA, self.sharedContextCache)
        self._predicates = None




    class StartContext(ParserRuleContext):

        def __init__(self, parser, parent:ParserRuleContext=None, invokingState:int=-1):
            super().__init__(parent, invokingState)
            self.parser = parser

        def init(self):
            return self.getTypedRuleContext(NFAParser.InitContext,0)


        def final(self):
            return self.getTypedRuleContext(NFAParser.FinalContext,0)


        def comment(self):
            return self.getTypedRuleContext(NFAParser.CommentContext,0)


        def production(self, i:int=None):
            if i is None:
                return self.getTypedRuleContexts(NFAParser.ProductionContext)
            else:
                return self.getTypedRuleContext(NFAParser.ProductionContext,i)


        def getRuleIndex(self):
            return NFAParser.RULE_start

        def enterRule(self, listener:ParseTreeListener):
            if hasattr( listener, "enterStart" ):
                listener.enterStart(self)

        def exitRule(self, listener:ParseTreeListener):
            if hasattr( listener, "exitStart" ):
                listener.exitStart(self)




    def start(self):

        localctx = NFAParser.StartContext(self, self._ctx, self.state)
        self.enterRule(localctx, 0, self.RULE_start)
        self._la = 0 # Token type
        try:
            self.enterOuterAlt(localctx, 1)
            self.state = 16
            self.init()
            self.state = 20
            self._errHandler.sync(self)
            _la = self._input.LA(1)
            while _la==NFAParser.LEFT_PARENTHESIS:
                self.state = 17
                self.production()
                self.state = 22
                self._errHandler.sync(self)
                _la = self._input.LA(1)

            self.state = 23
            self.final()
            self.state = 24
            self.comment()
        except RecognitionException as re:
            localctx.exception = re
            self._errHandler.reportError(self, re)
            self._errHandler.recover(self, re)
        finally:
            self.exitRule()
        return localctx


    class InitContext(ParserRuleContext):

        def __init__(self, parser, parent:ParserRuleContext=None, invokingState:int=-1):
            super().__init__(parent, invokingState)
            self.parser = parser

        def INIT(self):
            return self.getToken(NFAParser.INIT, 0)

        def EQUALS(self):
            return self.getToken(NFAParser.EQUALS, 0)

        def statename(self):
            return self.getTypedRuleContext(NFAParser.StatenameContext,0)


        def getRuleIndex(self):
            return NFAParser.RULE_init

        def enterRule(self, listener:ParseTreeListener):
            if hasattr( listener, "enterInit" ):
                listener.enterInit(self)

        def exitRule(self, listener:ParseTreeListener):
            if hasattr( listener, "exitInit" ):
                listener.exitInit(self)




    def init(self):

        localctx = NFAParser.InitContext(self, self._ctx, self.state)
        self.enterRule(localctx, 2, self.RULE_init)
        try:
            self.enterOuterAlt(localctx, 1)
            self.state = 30
            self._errHandler.sync(self)
            token = self._input.LA(1)
            if token in [NFAParser.INIT]:
                self.state = 26
                self.match(NFAParser.INIT)
                self.state = 27
                self.match(NFAParser.EQUALS)
                self.state = 28
                self.statename()
                pass
            elif token in [NFAParser.LEFT_PARENTHESIS, NFAParser.FINAL]:
                pass
            else:
                raise NoViableAltException(self)

        except RecognitionException as re:
            localctx.exception = re
            self._errHandler.reportError(self, re)
            self._errHandler.recover(self, re)
        finally:
            self.exitRule()
        return localctx


    class ProductionContext(ParserRuleContext):

        def __init__(self, parser, parent:ParserRuleContext=None, invokingState:int=-1):
            super().__init__(parent, invokingState)
            self.parser = parser

        def LEFT_PARENTHESIS(self):
            return self.getToken(NFAParser.LEFT_PARENTHESIS, 0)

        def statename(self, i:int=None):
            if i is None:
                return self.getTypedRuleContexts(NFAParser.StatenameContext)
            else:
                return self.getTypedRuleContext(NFAParser.StatenameContext,i)


        def COMMA(self):
            return self.getToken(NFAParser.COMMA, 0)

        def RIGHT_PARENTHESIS(self):
            return self.getToken(NFAParser.RIGHT_PARENTHESIS, 0)

        def EQUALS(self):
            return self.getToken(NFAParser.EQUALS, 0)

        def stateset(self):
            return self.getTypedRuleContext(NFAParser.StatesetContext,0)


        def EPSILON(self):
            return self.getToken(NFAParser.EPSILON, 0)

        def getRuleIndex(self):
            return NFAParser.RULE_production

        def enterRule(self, listener:ParseTreeListener):
            if hasattr( listener, "enterProduction" ):
                listener.enterProduction(self)

        def exitRule(self, listener:ParseTreeListener):
            if hasattr( listener, "exitProduction" ):
                listener.exitProduction(self)




    def production(self):

        localctx = NFAParser.ProductionContext(self, self._ctx, self.state)
        self.enterRule(localctx, 4, self.RULE_production)
        try:
            self.enterOuterAlt(localctx, 1)
            self.state = 32
            self.match(NFAParser.LEFT_PARENTHESIS)
            self.state = 33
            self.statename()
            self.state = 34
            self.match(NFAParser.COMMA)
            self.state = 37
            self._errHandler.sync(self)
            token = self._input.LA(1)
            if token in [NFAParser.STATE]:
                self.state = 35
                self.statename()
                pass
            elif token in [NFAParser.EPSILON]:
                self.state = 36
                self.match(NFAParser.EPSILON)
                pass
            else:
                raise NoViableAltException(self)

            self.state = 39
            self.match(NFAParser.RIGHT_PARENTHESIS)
            self.state = 40
            self.match(NFAParser.EQUALS)
            self.state = 41
            self.stateset()
        except RecognitionException as re:
            localctx.exception = re
            self._errHandler.reportError(self, re)
            self._errHandler.recover(self, re)
        finally:
            self.exitRule()
        return localctx


    class StatesetContext(ParserRuleContext):

        def __init__(self, parser, parent:ParserRuleContext=None, invokingState:int=-1):
            super().__init__(parent, invokingState)
            self.parser = parser

        def LEFT_BRACKET(self):
            return self.getToken(NFAParser.LEFT_BRACKET, 0)

        def RIGHT_BRACKET(self):
            return self.getToken(NFAParser.RIGHT_BRACKET, 0)

        def statename(self, i:int=None):
            if i is None:
                return self.getTypedRuleContexts(NFAParser.StatenameContext)
            else:
                return self.getTypedRuleContext(NFAParser.StatenameContext,i)


        def COMMA(self, i:int=None):
            if i is None:
                return self.getTokens(NFAParser.COMMA)
            else:
                return self.getToken(NFAParser.COMMA, i)

        def getRuleIndex(self):
            return NFAParser.RULE_stateset

        def enterRule(self, listener:ParseTreeListener):
            if hasattr( listener, "enterStateset" ):
                listener.enterStateset(self)

        def exitRule(self, listener:ParseTreeListener):
            if hasattr( listener, "exitStateset" ):
                listener.exitStateset(self)




    def stateset(self):

        localctx = NFAParser.StatesetContext(self, self._ctx, self.state)
        self.enterRule(localctx, 6, self.RULE_stateset)
        self._la = 0 # Token type
        try:
            self.enterOuterAlt(localctx, 1)
            self.state = 43
            self.match(NFAParser.LEFT_BRACKET)
            self.state = 53
            self._errHandler.sync(self)
            token = self._input.LA(1)
            if token in [NFAParser.STATE]:
                self.state = 44
                self.statename()
                self.state = 49
                self._errHandler.sync(self)
                _la = self._input.LA(1)
                while _la==NFAParser.COMMA:
                    self.state = 45
                    self.match(NFAParser.COMMA)
                    self.state = 46
                    self.statename()
                    self.state = 51
                    self._errHandler.sync(self)
                    _la = self._input.LA(1)

                pass
            elif token in [NFAParser.RIGHT_BRACKET]:
                pass
            else:
                raise NoViableAltException(self)

            self.state = 55
            self.match(NFAParser.RIGHT_BRACKET)
        except RecognitionException as re:
            localctx.exception = re
            self._errHandler.reportError(self, re)
            self._errHandler.recover(self, re)
        finally:
            self.exitRule()
        return localctx


    class FinalContext(ParserRuleContext):

        def __init__(self, parser, parent:ParserRuleContext=None, invokingState:int=-1):
            super().__init__(parent, invokingState)
            self.parser = parser

        def FINAL(self):
            return self.getToken(NFAParser.FINAL, 0)

        def EQUALS(self):
            return self.getToken(NFAParser.EQUALS, 0)

        def stateset(self):
            return self.getTypedRuleContext(NFAParser.StatesetContext,0)


        def getRuleIndex(self):
            return NFAParser.RULE_final

        def enterRule(self, listener:ParseTreeListener):
            if hasattr( listener, "enterFinal" ):
                listener.enterFinal(self)

        def exitRule(self, listener:ParseTreeListener):
            if hasattr( listener, "exitFinal" ):
                listener.exitFinal(self)




    def final(self):

        localctx = NFAParser.FinalContext(self, self._ctx, self.state)
        self.enterRule(localctx, 8, self.RULE_final)
        try:
            self.enterOuterAlt(localctx, 1)
            self.state = 57
            self.match(NFAParser.FINAL)
            self.state = 58
            self.match(NFAParser.EQUALS)
            self.state = 59
            self.stateset()
        except RecognitionException as re:
            localctx.exception = re
            self._errHandler.reportError(self, re)
            self._errHandler.recover(self, re)
        finally:
            self.exitRule()
        return localctx


    class StatenameContext(ParserRuleContext):

        def __init__(self, parser, parent:ParserRuleContext=None, invokingState:int=-1):
            super().__init__(parent, invokingState)
            self.parser = parser

        def STATE(self):
            return self.getToken(NFAParser.STATE, 0)

        def getRuleIndex(self):
            return NFAParser.RULE_statename

        def enterRule(self, listener:ParseTreeListener):
            if hasattr( listener, "enterStatename" ):
                listener.enterStatename(self)

        def exitRule(self, listener:ParseTreeListener):
            if hasattr( listener, "exitStatename" ):
                listener.exitStatename(self)




    def statename(self):

        localctx = NFAParser.StatenameContext(self, self._ctx, self.state)
        self.enterRule(localctx, 10, self.RULE_statename)
        try:
            self.enterOuterAlt(localctx, 1)
            self.state = 61
            self.match(NFAParser.STATE)
        except RecognitionException as re:
            localctx.exception = re
            self._errHandler.reportError(self, re)
            self._errHandler.recover(self, re)
        finally:
            self.exitRule()
        return localctx


    class CommentContext(ParserRuleContext):

        def __init__(self, parser, parent:ParserRuleContext=None, invokingState:int=-1):
            super().__init__(parent, invokingState)
            self.parser = parser

        def HASH(self):
            return self.getToken(NFAParser.HASH, 0)

        def anyvalue(self, i:int=None):
            if i is None:
                return self.getTypedRuleContexts(NFAParser.AnyvalueContext)
            else:
                return self.getTypedRuleContext(NFAParser.AnyvalueContext,i)


        def getRuleIndex(self):
            return NFAParser.RULE_comment

        def enterRule(self, listener:ParseTreeListener):
            if hasattr( listener, "enterComment" ):
                listener.enterComment(self)

        def exitRule(self, listener:ParseTreeListener):
            if hasattr( listener, "exitComment" ):
                listener.exitComment(self)




    def comment(self):

        localctx = NFAParser.CommentContext(self, self._ctx, self.state)
        self.enterRule(localctx, 12, self.RULE_comment)
        self._la = 0 # Token type
        try:
            self.enterOuterAlt(localctx, 1)
            self.state = 71
            self._errHandler.sync(self)
            token = self._input.LA(1)
            if token in [NFAParser.HASH]:
                self.state = 63
                self.match(NFAParser.HASH)
                self.state = 67
                self._errHandler.sync(self)
                _la = self._input.LA(1)
                while (((_la) & ~0x3f) == 0 and ((1 << _la) & ((1 << NFAParser.INIT) | (1 << NFAParser.EQUALS) | (1 << NFAParser.LEFT_PARENTHESIS) | (1 << NFAParser.RIGHT_PARENTHESIS) | (1 << NFAParser.LEFT_BRACKET) | (1 << NFAParser.RIGHT_BRACKET) | (1 << NFAParser.COMMA) | (1 << NFAParser.FINAL) | (1 << NFAParser.STATE) | (1 << NFAParser.ANYCHAR))) != 0):
                    self.state = 64
                    self.anyvalue()
                    self.state = 69
                    self._errHandler.sync(self)
                    _la = self._input.LA(1)

                pass
            elif token in [NFAParser.EOF]:
                pass
            else:
                raise NoViableAltException(self)

        except RecognitionException as re:
            localctx.exception = re
            self._errHandler.reportError(self, re)
            self._errHandler.recover(self, re)
        finally:
            self.exitRule()
        return localctx


    class AnyvalueContext(ParserRuleContext):

        def __init__(self, parser, parent:ParserRuleContext=None, invokingState:int=-1):
            super().__init__(parent, invokingState)
            self.parser = parser

        def INIT(self):
            return self.getToken(NFAParser.INIT, 0)

        def EQUALS(self):
            return self.getToken(NFAParser.EQUALS, 0)

        def LEFT_PARENTHESIS(self):
            return self.getToken(NFAParser.LEFT_PARENTHESIS, 0)

        def RIGHT_PARENTHESIS(self):
            return self.getToken(NFAParser.RIGHT_PARENTHESIS, 0)

        def LEFT_BRACKET(self):
            return self.getToken(NFAParser.LEFT_BRACKET, 0)

        def RIGHT_BRACKET(self):
            return self.getToken(NFAParser.RIGHT_BRACKET, 0)

        def COMMA(self):
            return self.getToken(NFAParser.COMMA, 0)

        def FINAL(self):
            return self.getToken(NFAParser.FINAL, 0)

        def STATE(self):
            return self.getToken(NFAParser.STATE, 0)

        def ANYCHAR(self):
            return self.getToken(NFAParser.ANYCHAR, 0)

        def getRuleIndex(self):
            return NFAParser.RULE_anyvalue

        def enterRule(self, listener:ParseTreeListener):
            if hasattr( listener, "enterAnyvalue" ):
                listener.enterAnyvalue(self)

        def exitRule(self, listener:ParseTreeListener):
            if hasattr( listener, "exitAnyvalue" ):
                listener.exitAnyvalue(self)




    def anyvalue(self):

        localctx = NFAParser.AnyvalueContext(self, self._ctx, self.state)
        self.enterRule(localctx, 14, self.RULE_anyvalue)
        self._la = 0 # Token type
        try:
            self.enterOuterAlt(localctx, 1)
            self.state = 73
            _la = self._input.LA(1)
            if not((((_la) & ~0x3f) == 0 and ((1 << _la) & ((1 << NFAParser.INIT) | (1 << NFAParser.EQUALS) | (1 << NFAParser.LEFT_PARENTHESIS) | (1 << NFAParser.RIGHT_PARENTHESIS) | (1 << NFAParser.LEFT_BRACKET) | (1 << NFAParser.RIGHT_BRACKET) | (1 << NFAParser.COMMA) | (1 << NFAParser.FINAL) | (1 << NFAParser.STATE) | (1 << NFAParser.ANYCHAR))) != 0)):
                self._errHandler.recoverInline(self)
            else:
                self._errHandler.reportMatch(self)
                self.consume()
        except RecognitionException as re:
            localctx.exception = re
            self._errHandler.reportError(self, re)
            self._errHandler.recover(self, re)
        finally:
            self.exitRule()
        return localctx





