# Generated from lib/parsing/NFA.g4 by ANTLR 4.8
from antlr4 import *
from io import StringIO
from typing.io import TextIO
import sys



def serializedATN():
    with StringIO() as buf:
        buf.write("\3\u608b\ua72a\u8133\ub9ed\u417c\u3be7\u7786\u5964\2\17")
        buf.write("I\b\1\4\2\t\2\4\3\t\3\4\4\t\4\4\5\t\5\4\6\t\6\4\7\t\7")
        buf.write("\4\b\t\b\4\t\t\t\4\n\t\n\4\13\t\13\4\f\t\f\4\r\t\r\4\16")
        buf.write("\t\16\3\2\3\2\3\2\3\2\3\2\3\3\3\3\3\4\3\4\3\5\3\5\3\6")
        buf.write("\3\6\3\7\3\7\3\b\3\b\3\t\3\t\3\t\3\t\3\t\3\t\3\n\3\n\3")
        buf.write("\n\5\n8\n\n\3\13\6\13;\n\13\r\13\16\13<\3\f\3\f\3\r\6")
        buf.write("\rB\n\r\r\r\16\rC\3\r\3\r\3\16\3\16\2\2\17\3\3\5\4\7\5")
        buf.write("\t\6\13\7\r\b\17\t\21\n\23\13\25\f\27\r\31\16\33\17\3")
        buf.write("\2\4\7\2))\62;C\\aac|\5\2\13\f\17\17\"\"\2K\2\3\3\2\2")
        buf.write("\2\2\5\3\2\2\2\2\7\3\2\2\2\2\t\3\2\2\2\2\13\3\2\2\2\2")
        buf.write("\r\3\2\2\2\2\17\3\2\2\2\2\21\3\2\2\2\2\23\3\2\2\2\2\25")
        buf.write("\3\2\2\2\2\27\3\2\2\2\2\31\3\2\2\2\2\33\3\2\2\2\3\35\3")
        buf.write("\2\2\2\5\"\3\2\2\2\7$\3\2\2\2\t&\3\2\2\2\13(\3\2\2\2\r")
        buf.write("*\3\2\2\2\17,\3\2\2\2\21.\3\2\2\2\23\67\3\2\2\2\25:\3")
        buf.write("\2\2\2\27>\3\2\2\2\31A\3\2\2\2\33G\3\2\2\2\35\36\7k\2")
        buf.write("\2\36\37\7p\2\2\37 \7k\2\2 !\7v\2\2!\4\3\2\2\2\"#\7?\2")
        buf.write("\2#\6\3\2\2\2$%\7*\2\2%\b\3\2\2\2&\'\7+\2\2\'\n\3\2\2")
        buf.write("\2()\7}\2\2)\f\3\2\2\2*+\7\177\2\2+\16\3\2\2\2,-\7.\2")
        buf.write("\2-\20\3\2\2\2./\7h\2\2/\60\7k\2\2\60\61\7p\2\2\61\62")
        buf.write("\7c\2\2\62\63\7n\2\2\63\22\3\2\2\2\648\7\u03b7\2\2\65")
        buf.write("\66\7^\2\2\668\7g\2\2\67\64\3\2\2\2\67\65\3\2\2\28\24")
        buf.write("\3\2\2\29;\t\2\2\2:9\3\2\2\2;<\3\2\2\2<:\3\2\2\2<=\3\2")
        buf.write("\2\2=\26\3\2\2\2>?\7%\2\2?\30\3\2\2\2@B\t\3\2\2A@\3\2")
        buf.write("\2\2BC\3\2\2\2CA\3\2\2\2CD\3\2\2\2DE\3\2\2\2EF\b\r\2\2")
        buf.write("F\32\3\2\2\2GH\13\2\2\2H\34\3\2\2\2\7\2\67:<C\3\b\2\2")
        return buf.getvalue()


class NFALexer(Lexer):

    atn = ATNDeserializer().deserialize(serializedATN())

    decisionsToDFA = [ DFA(ds, i) for i, ds in enumerate(atn.decisionToState) ]

    INIT = 1
    EQUALS = 2
    LEFT_PARENTHESIS = 3
    RIGHT_PARENTHESIS = 4
    LEFT_BRACKET = 5
    RIGHT_BRACKET = 6
    COMMA = 7
    FINAL = 8
    EPSILON = 9
    STATE = 10
    HASH = 11
    WS = 12
    ANYCHAR = 13

    channelNames = [ u"DEFAULT_TOKEN_CHANNEL", u"HIDDEN" ]

    modeNames = [ "DEFAULT_MODE" ]

    literalNames = [ "<INVALID>",
            "'init'", "'='", "'('", "')'", "'{'", "'}'", "','", "'#'" ]

    symbolicNames = [ "<INVALID>",
            "INIT", "EQUALS", "LEFT_PARENTHESIS", "RIGHT_PARENTHESIS", "LEFT_BRACKET", 
            "RIGHT_BRACKET", "COMMA", "FINAL", "EPSILON", "STATE", "HASH", 
            "WS", "ANYCHAR" ]

    ruleNames = [ "INIT", "EQUALS", "LEFT_PARENTHESIS", "RIGHT_PARENTHESIS", 
                  "LEFT_BRACKET", "RIGHT_BRACKET", "COMMA", "FINAL", "EPSILON", 
                  "STATE", "HASH", "WS", "ANYCHAR" ]

    grammarFileName = "NFA.g4"

    def __init__(self, input=None, output:TextIO = sys.stdout):
        super().__init__(input, output)
        self.checkVersion("4.8")
        self._interp = LexerATNSimulator(self, self.atn, self.decisionsToDFA, PredictionContextCache())
        self._actions = None
        self._predicates = None


